Xerces-C++: DOMNodeFilter Class Reference

Xerces-C++ 3.3.0

List of all members
DOMNodeFilter Class Referenceabstract

Filters are objects that know how to "filter out" nodes. More...

`#include <xercesc/dom/DOMNodeFilter.hpp>`

Inheritance diagram for DOMNodeFilter:

## Public Types
Public Constants
enum | FilterAction { FILTER_ACCEPT = 1 , FILTER_REJECT = 2 , FILTER_SKIP = 3 }
| Constants returned by acceptNode. More...
enum | ShowTypeMasks { SHOW_ALL = 0x0000FFFF , SHOW_ELEMENT = 0x00000001 , SHOW_ATTRIBUTE = 0x00000002 , SHOW_TEXT = 0x00000004 , SHOW_CDATA_SECTION = 0x00000008 , SHOW_ENTITY_REFERENCE = 0x00000010 , SHOW_ENTITY = 0x00000020 , SHOW_PROCESSING_INSTRUCTION = 0x00000040 , SHOW_COMMENT = 0x00000080 , SHOW_DOCUMENT = 0x00000100 , SHOW_DOCUMENT_TYPE = 0x00000200 , SHOW_DOCUMENT_FRAGMENT = 0x00000400 , SHOW_NOTATION = 0x00000800 }
| Constants for whatToShow. More...
typedef unsigned long | ShowType

## Public Member Functions
Destructor
virtual | ~DOMNodeFilter ()
| Destructor.
Functions introduced in DOM Level 2
virtual FilterAction | acceptNode (const DOMNode *node) const =0
| Test whether a specified node is visible in the logical view of a `DOMTreeWalker` or `DOMNodeIterator`.

## Protected Member Functions
Hidden constructors
| DOMNodeFilter ()

## Detailed Description

Filters are objects that know how to "filter out" nodes.

If a `DOMNodeIterator` or `DOMTreeWalker` is given a `DOMNodeFilter`, it applies the filter before it returns the next node. If the filter says to accept the node, the traversal logic returns it; otherwise, traversal looks for the next node and pretends that the node that was rejected was not there.

The DOM does not provide any filters. `DOMNodeFilter` is just an interface that users can implement to provide their own filters.

`DOMNodeFilters` do not need to know how to traverse from node to node, nor do they need to know anything about the data structure that is being traversed. This makes it very easy to write filters, since the only thing they have to know how to do is evaluate a single node. One filter may be used with a number of different kinds of traversals, encouraging code reuse.

See also the Document Object Model (DOM) Level 2 Traversal and Range Specification.

Since
  DOM Level 2

## Member Typedef Documentation

## ◆ ShowType

typedef unsigned long DOMNodeFilter::ShowType

## Member Enumeration Documentation

## ◆ FilterAction

enum DOMNodeFilter::FilterAction

Constants returned by acceptNode.

`FILTER_ACCEPT:` Accept the node. Navigation methods defined for `DOMNodeIterator` or `DOMTreeWalker` will return this node.

`FILTER_REJECT:` Reject the node. Navigation methods defined for `DOMNodeIterator` or `DOMTreeWalker` will not return this node. For `DOMTreeWalker`, the children of this node will also be rejected. `DOMNodeIterators` treat this as a synonym for `FILTER_SKIP.`

`FILTER_SKIP:` Skip this single node. Navigation methods defined for `DOMNodeIterator` or `DOMTreeWalker` will not return this node. For both `DOMNodeIterator` and `DOMTreeWalker`, the children of this node will still be considered.

Since
  DOM Level 2

Enumerator
FILTER_ACCEPT |
FILTER_REJECT |
FILTER_SKIP |

## ◆ ShowTypeMasks

enum DOMNodeFilter::ShowTypeMasks

Constants for whatToShow.

`SHOW_ALL:` Show all `DOMNode(s)`.

`SHOW_ELEMENT:` Show `DOMElement` nodes.

`SHOW_ATTRIBUTE:` Show `DOMAttr` nodes. This is meaningful only when creating an `DOMNodeIterator` or `DOMTreeWalker` with an attribute node as its `root`; in this case, it means that the attribute node will appear in the first position of the iteration or traversal. Since attributes are never children of other nodes, they do not appear when traversing over the document tree.

`SHOW_TEXT:` Show `DOMText` nodes.

`SHOW_CDATA_SECTION:` Show `DOMCDATASection` nodes.

`SHOW_ENTITY_REFERENCE:` Show `DOMEntityReference` nodes.

`SHOW_ENTITY:` Show `DOMEntity` nodes. This is meaningful only when creating an `DOMNodeIterator` or `DOMTreeWalker` with an `DOMEntity` node as its `root`; in this case, it means that the `DOMEntity` node will appear in the first position of the traversal. Since entities are not part of the document tree, they do not appear when traversing over the document tree.

`SHOW_PROCESSING_INSTRUCTION:` Show `DOMProcessingInstruction` nodes.

`SHOW_COMMENT:` Show `DOMComment` nodes.

`SHOW_DOCUMENT:` Show `DOMDocument` nodes.

`SHOW_DOCUMENT_TYPE:` Show `DOMDocumentType` nodes.

`SHOW_DOCUMENT_FRAGMENT:` Show `DOMDocumentFragment` nodes.

`SHOW_NOTATION:` Show `DOMNotation` nodes. This is meaningful only when creating an `DOMNodeIterator` or `DOMTreeWalker` with a `DOMNotation` node as its `root`; in this case, it means that the `DOMNotation` node will appear in the first position of the traversal. Since notations are not part of the document tree, they do not appear when traversing over the document tree.

Since
  DOM Level 2

Enumerator
SHOW_ALL |
SHOW_ELEMENT |
SHOW_ATTRIBUTE |
SHOW_TEXT |
SHOW_CDATA_SECTION |
SHOW_ENTITY_REFERENCE |
SHOW_ENTITY |
SHOW_PROCESSING_INSTRUCTION |
SHOW_COMMENT |
SHOW_DOCUMENT |
SHOW_DOCUMENT_TYPE |
SHOW_DOCUMENT_FRAGMENT |
SHOW_NOTATION |

## Constructor & Destructor Documentation

## ◆ DOMNodeFilter()

DOMNodeFilter::DOMNodeFilter | ( |  | ) |
| protected

## ◆ ~DOMNodeFilter()

virtual DOMNodeFilter::~DOMNodeFilter | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ acceptNode()

virtual FilterAction DOMNodeFilter::acceptNode | ( | const DOMNode * | node | ) | const
| pure virtual

Test whether a specified node is visible in the logical view of a `DOMTreeWalker` or `DOMNodeIterator`.

This function will be called by the implementation of `DOMTreeWalker` and `DOMNodeIterator`; it is not normally called directly from user code. (Though you could do so if you wanted to use the same filter to guide your own application logic.)

Parameters

  node | The node to check to see if it passes the filter or not.

Returns
  A constant to determine whether the node is accepted, rejected, or skipped, as defined above.

Since
  DOM Level 2

Implemented in DOMLSSerializerFilter.

The documentation for this class was generated from the following file:

- DOMNodeFilter.hpp